module.exports = errorHandler;

const response = require("./response")

function errorHandler(err, req, res, next) {
    if (typeof (err) === 'string') {
        // custom application error
        return res.status(400).json(response(false,err,[]));
    }

    if (err.name === 'ValidationError') {
        // mongoose validation error
        return res.status(400).json(response(false,err.message,[]));
    }

    if (err.name === 'UnauthorizedError') {
        // jwt authentication error
        return res.status(401).json(response(false,"Invalid Token",[]));
    }

    // default to 500 server error
    return res.status(500).json(response(false,err.message,[]));
}