﻿const config = require('config.json');
const jwt = require('jsonwebtoken');
const bcrypt = require('bcryptjs');
const db = require('_helpers/db').pool;
var {getErrorMessageFromDatabase} = require('_helpers/error-handler');
const mail = require("_helpers/mail");

module.exports = {
    authenticate,
    getAll,
    create,
    getById,
    update,
    email,
    delete: _delete
};
 
 async function authenticate(userParam) {
    username = userParam.username;
    const user = await db.query("SELECT id,email,name,password from users where email = ?", [username]);
    if (user[0].length < 1) {
        throw new Error('Invalid username or password');
    }
    var userRes = user[0][0];
    console.log("Login"+userRes);
    if (userRes && bcrypt.compareSync(userParam.password, userRes.password)) 
    {
        jwttoken = jwt.sign({ sub: userRes.id }, config.secret);
        var userObject = {
            jwttoken : jwttoken,
            name : userRes.name,
            emai : userRes.email
        }
        return userObject;
    }
    
}

async function getAll() {
  const result = await db.query("SELECT id,name,email from users");
  return result[0];
}

async function create(userParam) {
    if (!userParam.name) {
        throw new Error('Name is required')
    }

    if (!userParam.email) {
        throw new Error('Email is required')
    }

    if (!userParam.password) {
        throw new Error('Password is required')
    }

    if (userParam.password) {
        password = bcrypt.hashSync(userParam.password, 10);
    }
    name = userParam.name;
    email = userParam.email;
    await db.query(
        'INSERT INTO users SET name = ?, email = ?, password = ?',
        [ name, email, password]
    ); 
    return true; 
}

async function getById(id) {
    //console.log('getById '+id);
    const result = await db.query("SELECT id,name,email from users where id = ?", [id]);
    return result[0][0];
}

async function update(id, userParam) {
    const result = await db.query("SELECT id,name,email from users where id = ?", [id]);
    var user = result[0][0];
    // validate
    if (!user) throw 'User not found';

    // hash password if it was entered
    if (userParam.password) {
        password = bcrypt.hashSync(userParam.password, 10);
        await db.query("UPDATE users SET password = ? where id = ?", [password, id]);
    }else if(userParam.isloggedin){
        //logout update
    }else{
        name = userParam.name;
        await db.query("UPDATE users SET name = ? where id = ?", [name, id]);
    }
}

async function _delete(id) {
    await db.query("DELETE FROM users where id = ?", [id]);
}

async function email(id, userParam) {
    const result = await db.query("SELECT email from users where id = ?", [id]);
    var user = result[0][0];
    // validate
    if (!user) throw 'User not found';
    to = "sharmahemal@yahoo.com";
    subject = "This is test email";
    text = "This is test email send to the users";
    mail.sendEmail(to,subject,text);

}